VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CLibWalker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Durchluft das Project und ruft den Client zurck."
Option Explicit

Private mdPrj As CProject
Private mdLU As ILibUser


Public Sub Create(ByVal lu As ILibUser, ByVal sProjectFile As String, Optional ByVal fIncludeClasses As Boolean, Optional ByVal fIncludeStructures As Boolean, Optional ByVal fIncludeEnums As Boolean)
Attribute Create.VB_Description = "Startet den Dokumentiervorgang."
On Error GoTo hell
    ' Projekt
    If sProjectFile = "" Then GoTo hell
    Set mdPrj = New CProject
    Set mdLU = lu
    mdPrj.ConstructObject sProjectFile
    ' Nachricht
    mdLU.StartProject mdPrj
    ' Klassen?
    If fIncludeClasses Then
        mdLU.StartClasses mdPrj
        CreateClasses
        mdLU.EndClasses mdPrj
    End If
    ' Strukturen?
    If fIncludeStructures Then
        mdLU.StartStructures mdPrj
        CreateStructures
        mdLU.EndStructures mdPrj
    End If
    ' Aufzhlungen?
    If fIncludeEnums Then
        mdLU.StartEnums mdPrj
        CreateEnums
        mdLU.EndEnums mdPrj
    End If
    GoTo finally
hell:
finally:
On Error Resume Next
    mdPrj.Classes.Clear
    mdLU.EndProject mdPrj
    Set mdPrj = Nothing
End Sub
' Klassen
Private Sub CreateClasses()
On Error GoTo hell
    Dim Classes As NClasses, Class As CClass
    Set Classes = mdPrj.Classes
    Classes.Refresh
    For Each Class In Classes
        Class.Refresh
        If Class.Instancing <> clsPrivate Then
            If mdLU.StartClass(Class) = True Then GoTo hell
            CreateMembers Class
            If mdLU.EndClass(Class) = True Then GoTo hell
        End If
    Next Class
    GoTo finally
hell:
finally:
End Sub
Private Sub CreateMembers(ByVal Class As CClass)
On Error GoTo hell
    Dim mbrs As NMembers, mbr As CMember
    Set mbrs = Class.Members
    mbrs.Refresh
    For Each mbr In mbrs
        If mdLU.StartMember(mbr) = True Then GoTo hell
        CreateParameters mbr
        If mdLU.EndMember(mbr) = True Then GoTo hell
    Next mbr
    GoTo finally
hell:
finally:
On Error Resume Next
    mbrs.Clear
End Sub
Private Sub CreateParameters(ByVal mbr As CMember)
On Error GoTo hell
    Dim prms As NParameters, prm As CParameter
    Set prms = mbr.Parameters
    prms.Refresh
    For Each prm In prms
        If mdLU.Parameter(prm) = True Then GoTo hell
    Next prm
    GoTo finally
hell:
finally:
On Error Resume Next
    prms.Clear
End Sub
' Strukturen
Private Sub CreateStructures()
On Error GoTo hell
    Dim structs As NStructures, strct As CStructure
    Set structs = mdPrj.Structures
    structs.Refresh
    For Each strct In structs
        DoEvents
        If mdLU.StartStructure(strct) = True Then GoTo hell
        CreateElements strct
        If mdLU.EndStructure(strct) = True Then GoTo hell
    Next strct
    GoTo finally
hell:
finally:
On Error Resume Next
    structs.Clear
End Sub
Private Sub CreateElements(ByVal strct As CStructure)
On Error GoTo hell
    Dim elems As NElements, elm As CElement
    Set elems = strct.Elements
    elems.Refresh
    For Each elm In elems
        If mdLU.Element(elm) = True Then GoTo hell
    Next elm
    GoTo finally
hell:
finally:
On Error Resume Next
    elems.Clear
End Sub
' Aufzhlungen
Private Sub CreateEnums()
On Error GoTo hell
    Dim enms As NEnums, enm As CEnum
    Set enms = mdPrj.Enums
    enms.Refresh
    For Each enm In enms
        If mdLU.StartEnum(enm) = True Then GoTo hell
        CreateConstants enm
        If mdLU.EndEnum(enm) = True Then GoTo hell
    Next enm
    GoTo finally
hell:
finally:
On Error Resume Next
    enms.Clear
    End Sub
Private Sub CreateConstants(ByVal enm As CEnum)
On Error GoTo hell
    Dim cnsts As NConstants, cnst As CConstant
    Set cnsts = enm.Constants
    cnsts.Refresh
    For Each cnst In cnsts
        If mdLU.Constant(cnst) = True Then GoTo hell
    Next cnst
    GoTo finally
hell:
finally:
On Error Resume Next
    cnsts.Clear
End Sub
